# Generated by Django 2.0.5 on 2021-09-24 08:47

import custom_storages
from django.conf import settings
import django.contrib.postgres.fields
import django.contrib.postgres.fields.jsonb
from django.db import migrations, models
import django.db.models.deletion
import project_management.mixins
import project_management.models.project


default_project_type_and_phases = {
    "Deployment": [
        "Customer Touch",
        "Kickoff",
        "Configuration",
        "Cut over",
        "Documentation",
        "Project Close",
    ],
    "Assessment": [
        "Customer Touch",
        "Kickoff",
        "Information Gathering",
        "Analysis",
        "Documentation",
        "Project Close",
    ],
}


def create_default_project_types(apps, schema_editor):
    ProjectType = apps.get_model("project_management", "ProjectType")
    ProjectPhase = apps.get_model("project_management", "ProjectPhase")
    Provider = apps.get_model("accounts", "Provider")
    for provider in Provider.objects.all():
        for project_type_title, phases in default_project_type_and_phases.items():
            project_type, _ = ProjectType.objects.update_or_create(
                provider=provider,
                title=project_type_title,
                defaults={"title": project_type_title},
            )
            for pos, phase_title in enumerate(phases):
                ProjectPhase.objects.update_or_create(
                    project_type=project_type,
                    title=phase_title,
                    defaults={"title": phase_title, "order": pos + 1},
                )


def delete_default_project_types(apps, schema_editor):
    ProjectType = apps.get_model("project_management", "ProjectType")
    Provider = apps.get_model("accounts", "Provider")
    for provider in Provider.objects.all():
        for project_type_title, _ in default_project_type_and_phases.items():
            ProjectType.objects.filter(
                provider=provider, title=project_type_title
            ).delete()


def create_milestone_done_status(apps, schema_editor):
    """
    Creates the Done Milestone status for all providers if not available
    """

    MilestoneStatusSetting = apps.get_model(
        "project_management", "MilestoneStatusSetting"
    )
    Provider = apps.get_model("accounts", "Provider")

    MILESTONE_DONE_STATUS_COLOR = "#176f07"
    MilestoneStatusSetting.DONE = "Completed"
    for provider in Provider.objects.filter(is_active=True):
        done_status = MilestoneStatusSetting.objects.filter(
            provider=provider, title=MilestoneStatusSetting.DONE
        ).first()
        if not done_status:
            MilestoneStatusSetting.objects.create(
                provider=provider,
                title=MilestoneStatusSetting.DONE,
                color=MILESTONE_DONE_STATUS_COLOR,
            )


def delete_milestone_done_status(apps, schema_editor):
    MilestoneStatusSetting = apps.get_model(
        "project_management", "MilestoneStatusSetting"
    )
    MilestoneStatusSetting.DONE = "Completed"
    MilestoneStatusSetting.objects.filter(title=MilestoneStatusSetting.DONE).delete()


def create_activity_status_done_status(apps, schema_editor):
    """
    Creates the Done Milestone status for all providers if not available
    """

    ActivityStatusSetting = apps.get_model(
        "project_management", "ActivityStatusSetting"
    )
    Provider = apps.get_model("accounts", "Provider")

    ACTIVITY_DONE_STATUS_COLOR = "#176f07"
    ActivityStatusSetting.DONE = "Completed"
    for provider in Provider.objects.filter(is_active=True):
        done_status = ActivityStatusSetting.objects.filter(
            provider=provider, title=ActivityStatusSetting.DONE
        ).first()
        if not done_status:
            ActivityStatusSetting.objects.create(
                provider=provider,
                title=ActivityStatusSetting.DONE,
                color=ACTIVITY_DONE_STATUS_COLOR,
            )


def delete_activity_status_done_status(apps, schema_editor):
    ActivityStatusSetting = apps.get_model(
        "project_management", "ActivityStatusSetting"
    )
    ActivityStatusSetting.DONE = "Completed"
    ActivityStatusSetting.objects.filter(title=ActivityStatusSetting.DONE).delete()


def migrate_project_mail_settings(apps, schema_editor):
    # We get the model from the versioned app registry;
    # if we directly import it, it'll be the wrong version
    """
    Custom data migration to move CustomerTouchMeeting and CloseOutMeeting data from their respective
    mail setting model to generic mail setting model.
    """
    db_alias = schema_editor.connection.alias

    CustomerTouchMeetingTemplate = apps.get_model(
        "project_management", "CustomerTouchMeetingTemplate"
    )
    CloseOutMeetingTemplate = apps.get_model(
        "project_management", "CloseOutMeetingTemplate"
    )
    MeetingMailTemplate = apps.get_model("project_management", "MeetingMailTemplate")

    to_create_data = []

    customer_touch_qs = CustomerTouchMeetingTemplate.objects.all()
    for instance in customer_touch_qs:
        mail_instance = MeetingMailTemplate(
            provider=instance.provider,
            meeting_type="Customer Touch",
            email_body_text=instance.message_html,
            email_body_markdown=instance.message_markdown,
            email_subject=instance.email_subject,
            last_updated_by=instance.last_updated_by,
        )

        to_create_data.append(mail_instance)

    close_out_meeting_qs = CloseOutMeetingTemplate.objects.all()
    for instance in close_out_meeting_qs:
        mail_instance = MeetingMailTemplate(
            provider=instance.provider,
            meeting_type="Close Out",
            email_body_text=instance.project_acceptance_html,
            email_body_markdown=instance.project_acceptance_markdown,
            email_subject="",
            last_updated_by=instance.last_updated_by,
        )

        to_create_data.append(mail_instance)

    MeetingMailTemplate.objects.using(db_alias).bulk_create(to_create_data)


class Migration(migrations.Migration):

    replaces = [
        ("project_management", "0006_auto_20210324_1807"),
        ("project_management", "0007_auto_20210325_0815"),
        ("project_management", "0008_auto_20210326_1251"),
        ("project_management", "0009_auto_20210331_0804"),
        ("project_management", "0010_activitystatussetting_project"),
        ("project_management", "0011_auto_20210331_1109"),
        ("project_management", "0012_auto_20210401_0858"),
        ("project_management", "0013_auto_20210402_0754"),
        ("project_management", "0014_auto_20210407_1133"),
        ("project_management", "0015_meeting_meeting_type"),
        ("project_management", "0016_auto_20210419_1153"),
        ("project_management", "0017_auto_20210423_1228"),
        ("project_management", "0018_auto_20210426_1201"),
        ("project_management", "0019_milestone_done_status"),
        ("project_management", "0020_meetingattendee"),
        ("project_management", "0021_auto_20210428_1238"),
        ("project_management", "0022_meetingtemplate_meeting_type"),
        ("project_management", "0023_projectnote_meeting"),
        ("project_management", "0024_activity_status_done_status"),
        ("project_management", "0025_meeting_archive"),
        ("project_management", "0026_closeoutmeeting"),
        ("project_management", "0027_auto_20210510_0813"),
        ("project_management", "0028_meetingdocument"),
        ("project_management", "0029_auto_20210512_1324"),
        ("project_management", "0030_closeoutmeetingtemplate"),
        ("project_management", "0031_auto_20210514_0827"),
        (
            "project_management",
            "0032_remove_additionalsetting_project_acceptance_message",
        ),
        ("project_management", "0033_auto_20210514_1118"),
        ("project_management", "0034_customertouchmeeting_email_body_text"),
        ("project_management", "0035_auto_20210520_2010"),
        ("project_management", "0036_auto_20210524_1131"),
        ("project_management", "0037_auto_20210531_0404"),
        ("project_management", "0038_auto_20210531_0806"),
        ("project_management", "0039_auto_20210601_1139"),
        ("project_management", "0040_projectitemsarchive"),
        ("project_management", "0041_auto_20210602_0545"),
        ("project_management", "0042_changerequest_changerequestattachment"),
        ("project_management", "0043_auto_20210609_1225"),
        ("project_management", "0044_auto_20210610_1019"),
        ("project_management", "0045_auto_20210614_1109"),
        ("project_management", "0046_auto_20210616_0936"),
        ("project_management", "0047_auto_20210623_1353"),
        ("project_management", "0048_auto_20210628_1843"),
        ("project_management", "0049_auto_20210706_1016"),
        ("project_management", "0050_changerequestemailtemplate"),
        ("project_management", "0051_auto_20210707_0801"),
        ("project_management", "0052_auto_20210708_1647"),
        ("project_management", "0053_auto_20210719_0626"),
        ("project_management", "0054_auto_20210810_1124"),
        ("project_management", "0055_auto_20210816_1146"),
        ("project_management", "0056_projectitemsarchive_updated_on"),
        ("project_management", "0057_presalesengineerrolemapping"),
        ("project_management", "0058_timesheetentrydraft_timesheetentrysettings"),
        ("project_management", "0059_auto_20210922_1241"),
        ("project_management", "0060_timesheetentrysettings_project_open_statuses"),
        ("project_management", "0061_auto_20210924_0844"),
    ]

    dependencies = [
        ("accounts", "0097_profile_cco_id_acknowledged"),
        ("accounts", "0092_auto_20210322_1207"),
        (
            "project_management",
            "0005_auto_20210315_1152_squashed_0009_additionalsetting",
        ),
        ("document", "0050_auto_20201210_0831"),
        ("accounts", "0094_profile_system_member_crm_id"),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ("accounts", "0093_auto_20210419_1121"),
    ]

    operations = [
        migrations.AddIndex(
            model_name="project",
            index=models.Index(
                fields=["-updated_on"], name="project_man_updated_260d73_idx"
            ),
        ),
        migrations.RunPython(
            code=create_default_project_types,
            reverse_code=delete_default_project_types,
        ),
        migrations.AlterField(
            model_name="overallstatussetting",
            name="is_default",
            field=models.BooleanField(default=True),
        ),
        migrations.AddIndex(
            model_name="projectphase",
            index=models.Index(fields=["order"], name="project_man_order_5cd7dd_idx"),
        ),
        migrations.CreateModel(
            name="ProjectActivePhase",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("estimated_completion_date", models.DateTimeField(null=True)),
                ("updated_on", models.DateTimeField(auto_now=True)),
                (
                    "phase",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="+",
                        to="project_management.ProjectPhase",
                    ),
                ),
                (
                    "project",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="phases",
                        to="project_management.Project",
                    ),
                ),
                (
                    "provider",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="+",
                        to="accounts.Provider",
                    ),
                ),
                (
                    "status",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="+",
                        to="project_management.ActivityStatusSetting",
                    ),
                ),
            ],
        ),
        migrations.AddIndex(
            model_name="projectactivephase",
            index=models.Index(
                fields=["provider", "project"], name="project_man_provide_aad774_idx"
            ),
        ),
        migrations.AddField(
            model_name="activitystatussetting",
            name="project",
            field=models.ForeignKey(
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="+",
                to="project_management.Project",
            ),
        ),
        migrations.CreateModel(
            name="ProjectNote",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("note", models.TextField()),
                ("updated_on", models.DateTimeField(auto_now=True)),
                (
                    "author",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="+",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "project",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="notes",
                        to="project_management.Project",
                    ),
                ),
                (
                    "provider",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="+",
                        to="accounts.Provider",
                    ),
                ),
            ],
        ),
        migrations.AddIndex(
            model_name="projectnote",
            index=models.Index(
                fields=["provider", "project"], name="project_man_provide_acc2b3_idx"
            ),
        ),
        migrations.AddIndex(
            model_name="projectnote",
            index=models.Index(
                fields=["-updated_on"], name="project_man_updated_0a7ae0_idx"
            ),
        ),
        migrations.CreateModel(
            name="ActionItem",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("created_on", models.DateTimeField(auto_now_add=True)),
                ("updated_on", models.DateTimeField(auto_now=True)),
                ("description", models.TextField()),
                ("due_date", models.DateTimeField(null=True)),
                (
                    "owner",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="+",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "project",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="action_items",
                        to="project_management.Project",
                    ),
                ),
                (
                    "provider",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="+",
                        to="accounts.Provider",
                    ),
                ),
                (
                    "status",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="+",
                        to="project_management.ActivityStatusSetting",
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="CriticalPathItem",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("created_on", models.DateTimeField(auto_now_add=True)),
                ("updated_on", models.DateTimeField(auto_now=True)),
                ("description", models.TextField()),
                ("due_date", models.DateTimeField(null=True)),
                (
                    "owner",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="+",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "project",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="critical_path_items",
                        to="project_management.Project",
                    ),
                ),
                (
                    "provider",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="+",
                        to="accounts.Provider",
                    ),
                ),
                (
                    "status",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="+",
                        to="project_management.ActivityStatusSetting",
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="RiskItem",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("created_on", models.DateTimeField(auto_now_add=True)),
                ("updated_on", models.DateTimeField(auto_now=True)),
                ("description", models.TextField()),
                (
                    "impact",
                    models.PositiveSmallIntegerField(
                        choices=[(3, "High"), (2, "Medium"), (1, "Low")], default=1
                    ),
                ),
                (
                    "owner",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="+",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "project",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="risk_items",
                        to="project_management.Project",
                    ),
                ),
                (
                    "provider",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="+",
                        to="accounts.Provider",
                    ),
                ),
            ],
        ),
        migrations.AddIndex(
            model_name="riskitem",
            index=models.Index(
                fields=["provider", "project"], name="project_man_provide_eece5b_idx"
            ),
        ),
        migrations.AddIndex(
            model_name="riskitem",
            index=models.Index(
                fields=["-updated_on"], name="project_man_updated_d56e78_idx"
            ),
        ),
        migrations.AddIndex(
            model_name="criticalpathitem",
            index=models.Index(
                fields=["provider", "project"], name="project_man_provide_1fc253_idx"
            ),
        ),
        migrations.AddIndex(
            model_name="criticalpathitem",
            index=models.Index(
                fields=["-updated_on"], name="project_man_updated_e48e49_idx"
            ),
        ),
        migrations.AddIndex(
            model_name="actionitem",
            index=models.Index(
                fields=["provider", "project"], name="project_man_provide_fed91a_idx"
            ),
        ),
        migrations.AddIndex(
            model_name="actionitem",
            index=models.Index(
                fields=["-updated_on"], name="project_man_updated_e13b2a_idx"
            ),
        ),
        migrations.RemoveIndex(
            model_name="actionitem",
            name="project_man_updated_e13b2a_idx",
        ),
        migrations.RemoveIndex(
            model_name="criticalpathitem",
            name="project_man_updated_e48e49_idx",
        ),
        migrations.AddIndex(
            model_name="actionitem",
            index=models.Index(
                fields=["due_date"], name="project_man_due_dat_4b1fff_idx"
            ),
        ),
        migrations.AddIndex(
            model_name="criticalpathitem",
            index=models.Index(
                fields=["due_date"], name="project_man_due_dat_6b4c6f_idx"
            ),
        ),
        migrations.CreateModel(
            name="CustomerTouchMeeting",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("email_subject", models.CharField(max_length=1000)),
                ("email_body", models.TextField()),
            ],
        ),
        migrations.CreateModel(
            name="KickoffMeeting",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "agenda_topics",
                    django.contrib.postgres.fields.ArrayField(
                        base_field=models.CharField(max_length=1000),
                        null=True,
                        size=None,
                    ),
                ),
                ("is_internal", models.BooleanField(default=False)),
            ],
        ),
        migrations.CreateModel(
            name="Meeting",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("created_on", models.DateTimeField(auto_now_add=True)),
                ("updated_on", models.DateTimeField(auto_now=True)),
                ("name", models.TextField()),
                ("schedule_start_datetime", models.DateTimeField(null=True)),
                ("schedule_end_datetime", models.DateTimeField(null=True)),
                ("conducted_on", models.DateTimeField(null=True)),
                (
                    "project",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="+",
                        to="project_management.Project",
                    ),
                ),
                (
                    "provider",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="+",
                        to="accounts.Provider",
                    ),
                ),
                (
                    "status",
                    models.CharField(
                        choices=[("Planned", "Planned"), ("Done", "Done")],
                        default="Planned",
                        max_length=100,
                        null=True,
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="StatusMeeting",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "agenda_topics",
                    django.contrib.postgres.fields.ArrayField(
                        base_field=models.CharField(max_length=1000),
                        null=True,
                        size=None,
                    ),
                ),
                (
                    "meeting",
                    models.OneToOneField(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="+",
                        to="project_management.Meeting",
                    ),
                ),
            ],
        ),
        migrations.AddField(
            model_name="kickoffmeeting",
            name="meeting",
            field=models.OneToOneField(
                on_delete=django.db.models.deletion.CASCADE,
                related_name="+",
                to="project_management.Meeting",
            ),
        ),
        migrations.AddField(
            model_name="customertouchmeeting",
            name="meeting",
            field=models.OneToOneField(
                on_delete=django.db.models.deletion.CASCADE,
                related_name="+",
                to="project_management.Meeting",
            ),
        ),
        migrations.AddIndex(
            model_name="meeting",
            index=models.Index(
                fields=["provider", "project"], name="project_man_provide_18a8d8_idx"
            ),
        ),
        migrations.AddIndex(
            model_name="meeting",
            index=models.Index(
                fields=["schedule_start_datetime"],
                name="project_man_schedul_b3f2da_idx",
            ),
        ),
        migrations.AddField(
            model_name="meeting",
            name="meeting_type",
            field=models.CharField(
                choices=[
                    ("Status", "Status"),
                    ("Customer Touch", "Customer Touch"),
                    ("Internal Kickoff", "Internal Kickoff"),
                    ("Kickoff", "Kickoff"),
                    ("Close Out", "Close Out"),
                ],
                max_length=100,
            ),
        ),
        migrations.CreateModel(
            name="MilestoneStatusSetting",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("created_on", models.DateTimeField(auto_now_add=True)),
                ("updated_on", models.DateTimeField(auto_now=True)),
                (
                    "title",
                    models.CharField(
                        help_text="Title for this status.", max_length=100
                    ),
                ),
                (
                    "color",
                    models.CharField(
                        help_text="Hex Code for the color to be shown for this status.",
                        max_length=10,
                    ),
                ),
                (
                    "provider",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="pmo_milestone_status",
                        to="accounts.Provider",
                    ),
                ),
            ],
        ),
        migrations.AlterField(
            model_name="projectactivephase",
            name="status",
            field=models.ForeignKey(
                null=True,
                on_delete=django.db.models.deletion.SET_NULL,
                related_name="+",
                to="project_management.MilestoneStatusSetting",
            ),
        ),
        migrations.AlterUniqueTogether(
            name="milestonestatussetting",
            unique_together={("provider", "title")},
        ),
        migrations.CreateModel(
            name="ProjectContactRole",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("contact_crm_id", models.IntegerField(null=True)),
                (
                    "project",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="+",
                        to="project_management.Project",
                    ),
                ),
                (
                    "role",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="+",
                        to="project_management.CustomerContactRole",
                    ),
                ),
                (
                    "user",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="project_contact_roles",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
        ),
        migrations.AddIndex(
            model_name="projectcontactrole",
            index=models.Index(
                fields=["project", "contact_crm_id"],
                name="project_man_project_088534_idx",
            ),
        ),
        migrations.AlterUniqueTogether(
            name="projectcontactrole",
            unique_together={("project", "contact_crm_id")},
        ),
        migrations.AddField(
            model_name="additionalsetting",
            name="project_service_board",
            field=models.PositiveSmallIntegerField(null=True),
        ),
        migrations.AddField(
            model_name="additionalsetting",
            name="service_ticket_complete_status",
            field=models.PositiveSmallIntegerField(null=True),
        ),
        migrations.RunPython(
            code=create_milestone_done_status,
            reverse_code=delete_milestone_done_status,
        ),
        migrations.CreateModel(
            name="MeetingAttendee",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "attendee",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="+",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "meeting",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="attendees",
                        to="project_management.Meeting",
                    ),
                ),
            ],
        ),
        migrations.RenameModel(
            old_name="KickoffMeetingTemplate",
            new_name="MeetingTemplate",
        ),
        migrations.AddField(
            model_name="meetingtemplate",
            name="meeting_type",
            field=models.CharField(
                choices=[
                    ("Internal Kickoff", "Internal Kickoff"),
                    ("Kickoff", "Kickoff"),
                    ("Status", "Status"),
                ],
                default="Kickoff",
                max_length=100,
            ),
            preserve_default=False,
        ),
        migrations.AddField(
            model_name="projectnote",
            name="meeting",
            field=models.ForeignKey(
                null=True,
                on_delete=django.db.models.deletion.SET_NULL,
                related_name="meeting_notes",
                to="project_management.Meeting",
            ),
        ),
        migrations.RunPython(
            code=create_activity_status_done_status,
            reverse_code=delete_activity_status_done_status,
        ),
        migrations.CreateModel(
            name="MeetingArchive",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("payload", django.contrib.postgres.fields.jsonb.JSONField()),
                (
                    "meeting",
                    models.OneToOneField(
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        related_name="archive",
                        to="project_management.Meeting",
                    ),
                ),
                (
                    "project",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="+",
                        to="project_management.Project",
                    ),
                ),
                (
                    "provider",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="+",
                        to="accounts.Provider",
                    ),
                ),
            ],
        ),
        migrations.AddIndex(
            model_name="meetingarchive",
            index=models.Index(
                fields=["provider", "project", "meeting"],
                name="project_man_provide_0f3685_idx",
            ),
        ),
        migrations.AlterUniqueTogether(
            name="meetingarchive",
            unique_together={("provider", "project", "meeting")},
        ),
        migrations.CreateModel(
            name="CloseOutMeeting",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "meeting",
                    models.OneToOneField(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="+",
                        to="project_management.Meeting",
                    ),
                ),
                (
                    "project_acceptance_markdown",
                    models.TextField(blank=True, null=True),
                ),
                ("project_acceptance_text", models.TextField(blank=True, null=True)),
                ("email_subject", models.CharField(max_length=500, null=True)),
            ],
        ),
        migrations.AlterField(
            model_name="meeting",
            name="status",
            field=models.CharField(
                choices=[("Pending", "Pending"), ("Completed", "Completed")],
                default="Pending",
                max_length=100,
                null=True,
            ),
        ),
        migrations.CreateModel(
            name="MeetingDocument",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("created_on", models.DateTimeField(auto_now_add=True)),
                ("updated_on", models.DateTimeField(auto_now=True)),
                ("file_name", models.CharField(max_length=1000)),
                (
                    "file_path",
                    models.FileField(
                        blank=True,
                        null=True,
                        storage=custom_storages.OverwriteStorage(),
                        upload_to=project_management.models.project.meeting_file_upload_url,
                    ),
                ),
                (
                    "meeting",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="documents",
                        to="project_management.Meeting",
                    ),
                ),
                (
                    "uploaded_by",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.AlterUniqueTogether(
            name="overallstatussetting",
            unique_together=set(),
        ),
        migrations.CreateModel(
            name="CloseOutMeetingTemplate",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("created_on", models.DateTimeField(auto_now_add=True)),
                ("updated_on", models.DateTimeField(auto_now=True)),
                ("project_acceptance_html", models.TextField()),
                ("project_acceptance_markdown", models.TextField()),
                (
                    "last_updated_by",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "provider",
                    models.OneToOneField(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="close_out_meeting_template",
                        to="accounts.Provider",
                    ),
                ),
                ("email_subject", models.CharField(max_length=500, null=True)),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.AddField(
            model_name="customertouchmeeting",
            name="email_body_text",
            field=models.CharField(blank=True, max_length=1000, null=True),
        ),
        migrations.AlterField(
            model_name="riskitem",
            name="impact",
            field=models.PositiveSmallIntegerField(
                choices=[(3, "High"), (2, "Medium"), (1, "Low"), (0, "Mitigated")],
                default=1,
            ),
        ),
        migrations.CreateModel(
            name="MeetingMailTemplate",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("created_on", models.DateTimeField(auto_now_add=True)),
                ("updated_on", models.DateTimeField(auto_now=True)),
                (
                    "meeting_type",
                    models.CharField(
                        choices=[
                            ("Internal Kickoff", "Internal Kickoff"),
                            ("Kickoff", "Kickoff"),
                            ("Status", "Status"),
                        ],
                        max_length=100,
                    ),
                ),
                ("email_body_text", models.TextField()),
                ("email_body_markdown", models.TextField()),
                ("email_subject", models.CharField(max_length=500, null=True)),
                (
                    "last_updated_by",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "provider",
                    models.OneToOneField(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="meeting_mail_template",
                        to="accounts.Provider",
                    ),
                ),
            ],
        ),
        migrations.AlterUniqueTogether(
            name="meetingmailtemplate",
            unique_together={("provider", "meeting_type")},
        ),
        migrations.AlterField(
            model_name="meetingmailtemplate",
            name="meeting_type",
            field=models.CharField(
                choices=[
                    ("Status", "Status"),
                    ("Customer Touch", "Customer Touch"),
                    ("Internal Kickoff", "Internal Kickoff"),
                    ("Kickoff", "Kickoff"),
                    ("Close Out", "Close Out"),
                ],
                max_length=100,
            ),
        ),
        migrations.AddField(
            model_name="additionalsetting",
            name="project_completed_item_threshold",
            field=models.PositiveSmallIntegerField(
                default=7,
                help_text="Denotes the number after which a completed critical path item, action item and risk item should be moved to completed item list.",
            ),
        ),
        migrations.AddField(
            model_name="additionalsetting",
            name="project_item_due_date_threshold",
            field=models.PositiveSmallIntegerField(
                default=7,
                help_text="Denotes the number before due_date a critical path item or action item should be counted as pending item.",
            ),
        ),
        migrations.CreateModel(
            name="ProjectItemsArchive",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "item_type",
                    models.CharField(
                        choices=[
                            ("Critical Path Item", "Critical Path Item"),
                            ("Action Item", "Action Item"),
                            ("Risk Item", "Risk Item"),
                        ],
                        max_length=100,
                    ),
                ),
                ("blob", django.contrib.postgres.fields.jsonb.JSONField()),
                ("created_on", models.DateTimeField(auto_now_add=True)),
                (
                    "project",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="+",
                        to="project_management.Project",
                    ),
                ),
                (
                    "provider",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="+",
                        to="accounts.Provider",
                    ),
                ),
            ],
        ),
        migrations.AlterField(
            model_name="meetingmailtemplate",
            name="provider",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                related_name="meeting_mail_template",
                to="accounts.Provider",
            ),
        ),
        migrations.CreateModel(
            name="ChangeRequest",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("created_on", models.DateTimeField(auto_now_add=True)),
                ("updated_on", models.DateTimeField(auto_now=True)),
                ("name", models.CharField(max_length=500)),
                ("change_description", models.TextField(blank=True, null=True)),
                (
                    "technical_details",
                    models.TextField(
                        blank=True,
                        help_text="This field contains the technical details required to complete the requested change.",
                        null=True,
                    ),
                ),
                (
                    "estimated_engineering_hours",
                    models.PositiveSmallIntegerField(
                        default=0, help_text="Estimated Engineering Hours"
                    ),
                ),
                (
                    "estimated_project_management_hours",
                    models.PositiveSmallIntegerField(
                        default=0, help_text="Estimated Project Management Hours"
                    ),
                ),
                (
                    "is_zero_dollar_change_request",
                    models.BooleanField(
                        default=False,
                        help_text="If Zero Cost Change box is checked the Total Change Cost should be zero",
                    ),
                ),
                (
                    "internal_notes",
                    models.TextField(
                        blank=True,
                        help_text="This field contains the technical details required to complete the requested change",
                        null=True,
                    ),
                ),
                (
                    "assigned_to",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="+",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "last_updated_by",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="+",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "project",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="change_requests",
                        to="project_management.Project",
                    ),
                ),
                (
                    "provider",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="+",
                        to="accounts.Provider",
                    ),
                ),
                (
                    "requested_by",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="+",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "sow_document",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="+",
                        to="document.SOWDocument",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="ChangeRequestAttachment",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("created_on", models.DateTimeField(auto_now_add=True)),
                ("updated_on", models.DateTimeField(auto_now=True)),
                ("file_name", models.CharField(max_length=1000)),
                (
                    "file_path",
                    models.FileField(
                        blank=True,
                        null=True,
                        storage=custom_storages.OverwriteStorage(),
                        upload_to=project_management.models.project.ChangeRequestAttachment.change_request_attachment_file_upload_url,
                    ),
                ),
                (
                    "change_request",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="attachments",
                        to="project_management.ChangeRequest",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.RemoveField(
            model_name="changerequest",
            name="change_description",
        ),
        migrations.RemoveField(
            model_name="changerequest",
            name="estimated_engineering_hours",
        ),
        migrations.RemoveField(
            model_name="changerequest",
            name="estimated_project_management_hours",
        ),
        migrations.RemoveField(
            model_name="changerequest",
            name="internal_notes",
        ),
        migrations.RemoveField(
            model_name="changerequest",
            name="is_zero_dollar_change_request",
        ),
        migrations.RemoveField(
            model_name="changerequest",
            name="technical_details",
        ),
        migrations.AddField(
            model_name="changerequest",
            name="details",
            field=django.contrib.postgres.fields.jsonb.JSONField(default={}),
        ),
        migrations.AddField(
            model_name="changerequest",
            name="status",
            field=models.CharField(
                choices=[
                    ("Assigned", "Assigned"),
                    ("In Progress", "In Progress"),
                    ("Done", "Done"),
                ],
                default="Assigned",
                max_length=200,
            ),
        ),
        migrations.RunPython(
            code=migrate_project_mail_settings,
        ),
        migrations.AddField(
            model_name="actionitem",
            name="completed_on",
            field=models.DateField(null=True),
        ),
        migrations.AddField(
            model_name="activitystatussetting",
            name="is_default",
            field=models.BooleanField(default=False),
        ),
        migrations.AddField(
            model_name="criticalpathitem",
            name="completed_on",
            field=models.DateField(null=True),
        ),
        migrations.AddField(
            model_name="riskitem",
            name="completed_on",
            field=models.DateField(null=True),
        ),
        migrations.AddField(
            model_name="additionalsetting",
            name="default_business_unit",
            field=models.PositiveSmallIntegerField(
                help_text="Id of the business unit to be used as default value when adding time entries for project ticket",
                null=True,
            ),
        ),
        migrations.AddField(
            model_name="additionalsetting",
            name="default_work_role",
            field=models.PositiveSmallIntegerField(
                help_text="Id of the work role to be used as default value when adding time entries for project ticket",
                null=True,
            ),
        ),
        migrations.AddField(
            model_name="additionalsetting",
            name="default_work_type",
            field=models.PositiveSmallIntegerField(
                help_text="Id of the work type to be used as default value when adding time entries for project ticket",
                null=True,
            ),
        ),
        migrations.AddField(
            model_name="additionalsetting",
            name="default_opportunity_stage",
            field=models.PositiveSmallIntegerField(
                help_text="Id of the Opportunity stage to be used to create opportunity for a change request",
                null=True,
            ),
        ),
        migrations.AddField(
            model_name="additionalsetting",
            name="default_opportunity_type",
            field=models.PositiveSmallIntegerField(
                help_text="Id of the Opportunity type to be used to create opportunity for a change request",
                null=True,
            ),
        ),
        migrations.RemoveField(
            model_name="changerequest",
            name="details",
        ),
        migrations.AddField(
            model_name="changerequest",
            name="change_number",
            field=models.PositiveIntegerField(default=1),
            preserve_default=False,
        ),
        migrations.AlterField(
            model_name="changerequest",
            name="status",
            field=models.CharField(
                choices=[
                    ("Cancelled/Rejected", "Cancelled/Rejected"),
                    ("In Progress", "In Progress"),
                    ("Approved", "Approved"),
                ],
                default="In Progress",
                max_length=200,
            ),
        ),
        migrations.CreateModel(
            name="ChangeRequestEmailTemplate",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("created_on", models.DateTimeField(auto_now_add=True)),
                ("updated_on", models.DateTimeField(auto_now=True)),
                ("email_body_text", models.TextField()),
                ("email_body_markdown", models.TextField()),
                ("email_subject", models.CharField(max_length=500, null=True)),
                (
                    "last_updated_by",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                (
                    "provider",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="+",
                        to="accounts.Provider",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.RemoveField(
            model_name="closeoutmeetingtemplate",
            name="last_updated_by",
        ),
        migrations.RemoveField(
            model_name="closeoutmeetingtemplate",
            name="provider",
        ),
        migrations.RemoveField(
            model_name="customertouchmeetingtemplate",
            name="last_updated_by",
        ),
        migrations.RemoveField(
            model_name="customertouchmeetingtemplate",
            name="provider",
        ),
        migrations.DeleteModel(
            name="CloseOutMeetingTemplate",
        ),
        migrations.DeleteModel(
            name="CustomerTouchMeetingTemplate",
        ),
        migrations.AlterField(
            model_name="riskitem",
            name="created_on",
            field=models.DateTimeField(),
        ),
        migrations.AlterField(
            model_name="meetingdocument",
            name="file_path",
            field=models.FileField(
                blank=True,
                max_length=1000,
                null=True,
                storage=custom_storages.OverwriteStorage(),
                upload_to=project_management.models.project.meeting_file_upload_url,
            ),
        ),
        migrations.AddField(
            model_name="actionitem",
            name="notes",
            field=models.TextField(blank=True, null=True),
        ),
        migrations.AddField(
            model_name="criticalpathitem",
            name="notes",
            field=models.TextField(blank=True, null=True),
        ),
        migrations.AddField(
            model_name="riskitem",
            name="notes",
            field=models.TextField(blank=True, null=True),
        ),
        migrations.AddField(
            model_name="additionalsetting",
            name="engineer_default_business_unit",
            field=models.PositiveSmallIntegerField(
                help_text="Id of the business unit to be used as default value when adding time entries for project ticket for engineers.",
                null=True,
            ),
        ),
        migrations.AddField(
            model_name="additionalsetting",
            name="engineer_default_work_role",
            field=models.PositiveSmallIntegerField(
                help_text="Id of the work role to be used as default value when adding time entries for project ticket for engineers.",
                null=True,
            ),
        ),
        migrations.AddField(
            model_name="additionalsetting",
            name="engineer_default_work_type",
            field=models.PositiveSmallIntegerField(
                help_text="Id of the work type to be used as default value when adding time entries for project ticket for engineers.",
                null=True,
            ),
        ),
        migrations.AddField(
            model_name="projectitemsarchive",
            name="updated_on",
            field=models.DateTimeField(null=True),
        ),
        migrations.CreateModel(
            name="PreSalesEngineerRoleMapping",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "role_ids",
                    django.contrib.postgres.fields.ArrayField(
                        base_field=models.IntegerField(), size=None
                    ),
                ),
                (
                    "provider",
                    models.OneToOneField(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="accounts.Provider",
                    ),
                ),
            ],
            bases=(project_management.mixins.ProjectSettingAuditMixin, models.Model),
        ),
        migrations.CreateModel(
            name="TimesheetEntryDraft",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("draft", django.contrib.postgres.fields.jsonb.JSONField(default={})),
                (
                    "provider",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="+",
                        to="accounts.Provider",
                    ),
                ),
                (
                    "user",
                    models.OneToOneField(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="+",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="TimesheetEntrySettings",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "time_period_open_status_ids",
                    django.contrib.postgres.fields.ArrayField(
                        base_field=models.PositiveIntegerField(), default=[], size=None
                    ),
                ),
                ("default_work_type_id", models.PositiveIntegerField()),
                ("time_period_status_id", models.PositiveIntegerField()),
                (
                    "provider",
                    models.OneToOneField(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="+",
                        to="accounts.Provider",
                    ),
                ),
            ],
        ),
    ]
